%define major 0
%define libname %mklibname moon %major
%define develname %mklibname -d moon
%define monover 2.6.1
%define monobasicver 2.6

Summary: Open Source implementation of Silverlight
Name: moonlight
Version: 2.4.1
Release: 2
Source0: http://ftp.novell.com/pub/mono/sources/moon/%version/%name-%{version}.tar.bz2
#gw these differ from the release tarballs
Source1: http://ftp.novell.com/pub/mono/sources/moon/%version/mono-%monover.tar.bz2
Source2: http://ftp.novell.com/pub/mono/sources/moon/%version/mono-basic-%monobasicver.tar.bz2
Patch: moon-2.0-format-strings.patch
Patch1: moon-2.0-fix-linkage.patch
#gw fix building with --no-undefined enabled
Patch5: mono-2.0-fix-linking.patch
Patch8: mono-2.6-format-strings.patch
Patch9:  bad-register.patch
Patch11: moonlight-2.3-firefox-4.0.patch
Patch13: moonlight-2.4.1-drop-dead-curl-header.patch
License: LGPLv2
Group: System/Libraries
Url: http://www.mono-project.com/Moonlight
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
%if %mdvver >= 201200
BuildRequires: ffmpeg0.7-devel
%else
BuildRequires: ffmpeg-devel
%endif
BuildRequires: libxtst-devel
BuildRequires: libxrandr-devel
%if %mdvver >= 201000
BuildRequires: xulrunner-devel
%else
BuildRequires: xulrunner-devel-unstable
%endif
BuildRequires: cairo-devel >= 1.6
BuildRequires: gnome-desktop-sharp-devel
BuildRequires: chrpath
BuildRequires: libgtk+2.0-devel
BuildRequires: libmagick-devel
BuildRequires: dbus-glib-devel
BuildRequires: libalsa-devel
BuildRequires: libpulseaudio-devel
BuildRequires: mono-devel >= 2.6
%if %mdvver >= 201100
BuildRequires: ndesk-dbus-devel 
%else
BuildRequires: ndesk-dbus
%endif
BuildRequires: curl-devel
BuildRequires: bison
BuildRequires: zip
Requires: %libname >= %version
Provides: moon
Obsoletes: moon

%description
Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems. It supports rich browser applications, similar to
Adobe Flash.

%package doc
Summary:	Documentation for %name
Group:		Development/Other
Requires(post): mono-tools >= 1.1.9
Requires(postun): mono-tools >= 1.1.9

%description doc
This package provides API documentation for %name.

%package -n %libname
Group:System/Libraries
Summary: Open Source implementation of Silverlight

%description -n %libname
Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems. It supports rich browser applications, similar to
Adobe Flash.

%package -n %develname
Group:Development/C++
Summary: Open Source implementation of Silverlight
Requires: %libname = %version-%release
Provides: libmoon-devel = %version-%release
Provides: %name-devel = %version-%release

%description -n %develname
Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems. It supports rich browser applications, similar to
Adobe Flash.


%prep
%setup -q -a 1 -a 2
%patch -p1
%patch1 -p1 -b .fix-linking~
%if %mdvver >= 201100
%patch11 -p1
%endif
%patch13 -p1 -b .curl~
autoreconf -fi
cd mono-%monover
%patch5 -p1 -b .linking~
%patch8 -p1 -b .format-strings~
%patch9
cd ../mono-basic-%monobasicver/vbnc/vbnc
#gw rename source file with parenthesis
sed -i -e "s^(^^" -e "s^)^^" vbnc.exe.sources
for x in source/Parser/Parser\(*.vb;do
  mv "$x" $(echo "$x" | sed -e "s^(^^" -e "s^)^^")
done


%build
TOP=`pwd`
cd mono-%{monover}
./configure --prefix=${TOP}/install \
            --with-mcs-docs=no \
            --with-ikvm-native=no

make EXTERNAL_MCS=false EXTERNAL_RUNTIME=false
make install
cd ..
# libtool is evil, if the .la is present things get jacked up
find install -name \*.la -delete
# Configure against the junk install of mono
export PATH=${TOP}/install/bin:${PATH}
export LD_LIBRARY_PATH=${TOP}/install/lib:${LD_LIBRARY_PATH}
export PKG_CONFIG_PATH=${TOP}/install/lib/pkgconfig:${PKG_CONFIG_PATH}
# And then we build moonlight
%configure2_5x --without-testing --without-performance --without-examples \
  --disable-debug --disable-sanity \
  --with-ff3=yes \
  --with-cairo=system \
  --with-mcspath=${TOP}/mono-%{monover}/mcs --with-mono-basic-path=${TOP}/mono-basic-%{monobasicver} \
  --with-curl=system \
  --enable-desktop-support --enable-sdk
# We need the system gac for gtk-sharp
# Only if we're linking to the junk mono
export MONO_GAC_PREFIX=${TOP}/install:%{_prefix}
#gw parallel build does not work in 2.0
make

%install
rm -rf %{buildroot}

%makeinstall_std 
mkdir -p %buildroot%_libdir/mozilla/plugins
export PATH=%{_builddir}/%name-%version/install/bin:${PATH}
export LD_LIBRARY_PATH=%{_builddir}/%name-%version/install/lib:${LD_LIBRARY_PATH}
export PKG_CONFIG_PATH=%{_builddir}/%name-%version/install/lib/pkgconfig:${PKG_CONFIG_PATH}
%{__make} install DESTDIR=%{buildroot}
# Copy the custom libmono.so.0 for the plugin to use
install -m 644 %{_builddir}/%name-%version/install/lib/libmono.so.0 %{buildroot}%{_libdir}/moonlight/
# Make the loader pull in the correct libmono
chrpath -r  %{_libdir}/moonlight %{buildroot}%{_libdir}/moonlight/plugin/libmoon*.so
ln -s %_libdir/moonlight/plugin/libmoonloader.so %buildroot%_libdir/mozilla/plugins
rm -f %buildroot%_libdir/moon/plugin/README

%clean
rm -rf %{buildroot}

%post doc
%_bindir/monodoc --make-index > /dev/null

%postun doc
if [ "$1" = "0" -a -x %_bindir/monodoc ]; then %_bindir/monodoc --make-index > /dev/null
fi

%files
%defattr(-,root,root)
%doc README TODO
%_bindir/mopen
%_bindir/mxap
%_bindir/respack
%_bindir/smcs
%_bindir/sockpol
%_bindir/unrespack
%_bindir/xaml2html
%_bindir/xamlg
%_prefix/lib/mono/gac/Moon*
%_prefix/lib/mono/gac/System.Windows.Browser/
%_prefix/lib/mono/gac/System.Windows.Controls/
%_prefix/lib/mono/gac/System.Windows.Controls.Data/
%_prefix/lib/mono/gac/System.Windows
%_libdir/mozilla/plugins/libmoon*
%dir %_prefix/lib/mono/%name
%_prefix/lib/mono/%name/*.dll
%dir %_prefix/lib/%name
%dir %_prefix/lib/%name/2.0-redist
%_prefix/lib/%name/2.0-redist/*
%dir %_prefix/lib/%name/2.0
%_prefix/lib/%name/2.0/*
%dir %_libdir/%name
%_libdir/%name/mopen.exe*
%_libdir/%name/mxap.exe*
%_libdir/%name/respack.exe*
%_libdir/%name/sockpol.exe*
%_libdir/%name/xaml2html.exe*
%_libdir/%name/xamlg.exe*
%dir %_libdir/%name/plugin
%_libdir/%name/plugin/*.*
%_mandir/man1/mopen.1*
%_mandir/man1/mxap.1*
%_mandir/man1/respack.1*
%_mandir/man1/sockpol.1*
%_mandir/man1/svg2xaml.1*
%_mandir/man1/xamlg.1*

%files -n %libname
%defattr(-,root,root)
%_libdir/libmoon.so.%{major}*
%{_libdir}/moonlight/libmono.so.%{major}*

%files -n %develname
%defattr(-,root,root)
%_bindir/munxap
%_libdir/%name/munxap.exe*
%_libdir/libmoon.so
%_datadir/pkgconfig/%{name}*.pc

%files doc
%defattr(-,root,root)
%_prefix/lib/monodoc/sources/%name-gtk*


%changelog
* Fri Dec 16 2011 Götz Waschk <waschk@mandriva.org> 2.4.1-2
+ Revision: 743051
- update linking patches
- remove libtool archive
- build against ffmpeg 0.7
- update build deps
- rebuild for gtk+ packaging breakage

* Tue Jul 12 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.4.1-1
+ Revision: 689696
- fix some build issues
  new version

* Thu Sep 16 2010 Götz Waschk <waschk@mandriva.org> 2.3-2mdv2011.0
+ Revision: 578864
- disable unnessessary stuff
- fix rpath
- fix build deps for backports

* Wed Sep 15 2010 Götz Waschk <waschk@mandriva.org> 2.3-1mdv2011.0
+ Revision: 578693
- new version
- patch to make it build with the new firefox
- update mono and mono-basic snapshots
- add patches from Suse
- fix build and installation

* Thu Jul 15 2010 Funda Wang <fwang@mandriva.org> 2.0-5mdv2011.0
+ Revision: 553469
- rebuild for new imagemagick

* Fri May 28 2010 Götz Waschk <waschk@mandriva.org> 2.0-4mdv2010.1
+ Revision: 546498
- move munxap to devel package (bug #59532)

* Thu Jan 14 2010 Funda Wang <fwang@mandriva.org> 2.0-3mdv2010.1
+ Revision: 491446
- rebuild for new imagemagick

* Sun Dec 20 2009 Funda Wang <fwang@mandriva.org> 2.0-2mdv2010.1
+ Revision: 480342
- fix symbolic link (bug#56551)

* Sun Dec 20 2009 Götz Waschk <waschk@mandriva.org> 2.0-1mdv2010.1
+ Revision: 480282
- rename from moon
- new version
- bundle mono and mono-basic for build
- rediff patches
- fix detection of firefox 3.6
- update build deps
- add doc package
- update file list

* Sun Nov 08 2009 Götz Waschk <waschk@mandriva.org> 1.0.1-3mdv2010.1
+ Revision: 462954
- update build deps
- add missing mozilla header
- update deps

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

* Wed Mar 11 2009 Götz Waschk <waschk@mandriva.org> 1.0.1-1mdv2009.1
+ Revision: 353813
- update to new version 1.0.1

* Thu Feb 12 2009 Götz Waschk <waschk@mandriva.org> 1.0-3mdv2009.1
+ Revision: 339928
- fix path of the moonloader plugin for moonshine

* Wed Jan 28 2009 Götz Waschk <waschk@mandriva.org> 1.0-2mdv2009.1
+ Revision: 335017
- fix patch 0
- fix build with the new libtool

* Tue Jan 20 2009 Götz Waschk <waschk@mandriva.org> 1.0-1mdv2009.1
+ Revision: 331809
- new version
- fix format strings
- update build deps

* Tue Dec 02 2008 Funda Wang <fwang@mandriva.org> 1.0-0.b1.1mdv2009.1
+ Revision: 309224
- New version 1.0 b1
- rediff linkage patch
- expat patch merged into linkage
- ffmpeg patch not needed

* Thu Nov 13 2008 Oden Eriksson <oeriksson@mandriva.com> 0.8-3mdv2009.1
+ Revision: 302737
- rebuilt against new libxcb

* Mon Oct 13 2008 Götz Waschk <waschk@mandriva.org> 0.8-2mdv2009.1
+ Revision: 293109
- build with new ffmpeg
- fix for backports
- fix build deps for backports

* Wed Aug 20 2008 Götz Waschk <waschk@mandriva.org> 0.8-1mdv2009.0
+ Revision: 274304
- new version
- fix build
- update file list
- update build deps
- rediff patch 0

* Thu Jul 03 2008 Götz Waschk <waschk@mandriva.org> 0.7-2mdv2009.0
+ Revision: 230897
- fix build with --no-undefined

* Thu Jul 03 2008 Götz Waschk <waschk@mandriva.org> 0.7-1mdv2009.0
+ Revision: 230887
- new version
- disable --no-undefined
- fix URL

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Wed May 14 2008 Götz Waschk <waschk@mandriva.org> 0.6-1mdv2009.0
+ Revision: 207067
- import moon

